<?php
class Ameex_Insurance_Block_Adminhtml_Reports_ActivationDetails_EditFormContainer_Edit_Tab_Form extends Mage_Adminhtml_Block_Widget_Form
{
	protected function _prepareForm()
	{
		$form = new Varien_Data_Form();
		$this->setForm($form);
		$fieldset = $form->addFieldset('activation_details', array('legend'=>Mage::helper('ameex_insurance')->__('Activation Details')));
	 
		$model = Mage::registry('activation_details');
		$companyId = $model->getInsuranceCompanyId();
		$company = Mage::getModel("ameex_insurance/company")->load($companyId);
		$model->setCompanyName($company->getName());
		$model->setCompanyEmail($company->getEmail());
		$activationCode = $model->getActivationCode();
		$activationCode = str_replace("\n",", ",$activationCode);
		$model->setActivationCode($activationCode);

		if ($model->getActivatedAt() <= 0) {
			$model->setActivatedAt("");
		}

		$fieldset->addField('activated_at', 'date', array(
			'label'     => Mage::helper('ameex_insurance')->__('Activated At'),
			'name'      => 'activated_at',
			'disabled'	=> true,
			'format'    => Mage::app()->getLocale()->getDateFormat(Mage_Core_Model_Locale::FORMAT_TYPE_SHORT),
			'after_element_html' => "<strong>MM/DD/YYYY</strong>",
		));
		
		$fieldset->addField('first_name', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('First Name'),
			'name'      => 'first_name',
		));

		$fieldset->addField('last_name', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Last Name'),
			'name'      => 'last_name',
		));

		$fieldset->addField('email', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('E-mail'),
			'name'      => 'email',
		));

		$fieldset->addField('phone', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Phone'),
			'name'      => 'phone',
		));

		$fieldset->addField('address1', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Address'),
			'name'      => 'address1',
		));

		$fieldset->addField('address2', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__(' '),
			'name'      => 'address2',
		));

		$fieldset->addField('city', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('City'),
			'name'      => 'city',
		));

		$fieldset->addField('state', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('State'),
			'name'      => 'state',
		));

		$fieldset->addField('zipcode', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Zipcode'),
			'name'      => 'zipcode',
		));

		$fieldset->addField('country', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Country'),
			'name'      => 'country',
		));

		$fieldset->addField('imei', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('IMEI'),
			'name'      => 'imei',
		));

		$fieldset->addField('manufacturer', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Manufacturer'),
			'name'      => 'manufacturer',
		));

		$fieldset->addField('phone_model', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Phone Model'),
			'name'      => 'phone_model',
		));

		$fieldset->addField('cellphone', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Cell Phone'),
			'name'      => 'cellphone',
		));

		$fieldset->addField('activation_code', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Activation Code'),
			'name'      => 'activation_code',
		));

		$fieldset->addField('carrier', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Carrier'),
			'name'      => 'carrier',
		));

        $fieldset->addField('date_purchased', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Date Purchased'),
			'name'      => 'date_purchased',
		));
		$fieldset->addField('company_name', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Company Name'),
			'name'      => 'company_name',
		));

		$fieldset->addField('company_email', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Company E-mail'),
			'name'      => 'company_email',
		));
		
	 	if(!is_null($model))
			$form->setValues($model->getData());
			
		return parent::_prepareForm();
	}
}
