<?php

class Magegiant_Affiliate_Block_Sales_Ordertotalaffiliate extends Mage_Sales_Block_Order_Totals
{
    public function getAffiliateDiscount()
    {
        $order = $this->getOrder();

        return $order->getAffiliateDiscount();
    }

    public function getBaseAffiliateDiscount()
    {
        $order = $this->getOrder();

        return $order->getBaseAffiliateDiscount();
    }

    public function initTotals()
    {
        $amount = $this->getAffiliateDiscount();
        if (floatval($amount)) {
            $total = new Varien_Object();
            $total->setCode('affiliate_discount');
            $total->setValue($amount);
            $total->setBaseValue($this->getBaseAffiliateDiscount());
            $total->setLabel('Affiliate Discount' . $this->getAffiliateCouponLabel());
            $parent = $this->getParentBlock();
            $parent->addTotal($total, 'subtotal');
        }
    }

    public function getAffiliateCouponLabel()
    {
        $order = $this->getOrder();
        if ($order->getAffiliateCoupon()) {
            return ' (' . $order->getAffiliateCoupon() . ')';
        } elseif ($order->getOrder()) {
            if ($order->getOrder()->getAffiliateCoupon()) {
                return ' (' . $order->getOrder()->getAffiliateCoupon() . ')';
            }
        }

        return '';
    }

    public function getOrder()
    {
        if (!$this->hasData('order')) {
            $parent = $this->getParentBlock();
            if ($parent instanceof Mage_Adminhtml_Block_Sales_Order_Invoice_Totals) {
                $order = $parent->getInvoice();
            } elseif ($parent instanceof Mage_Adminhtml_Block_Sales_Order_Creditmemo_Totals) {
                $order = $parent->getCreditmemo();
            } else {
                $order = $this->getParentBlock()->getOrder();
            }
            $this->setData('order', $order);
        }

        return $this->getData('order');
    }
}